{ovladanie textu,pola}
{urobit program pomocou games unity - ovladanie(ok),text(--)}
{text urobit s tym, ze v stringoch su ulozene znaky v poradi games unity}
{vytvoreny podprogram na zapamatanie obsahu riadku a na spatne vypisanie}
{urobit kurzor - ok}
{ - alt+127 - miesto space}
{ - alt+245 - miesto '}
Program mnotes;

uses crt,games;
Type
  ShadeType = (Shading, NoShading);
  ScreenBlock = Array [1..2000] of Integer;
  ScreenLine  = Array [1..80] of Word;
  ScreenArray = Array [1..25] of ScreenLine;
  WindowLink  = ^WindowControlBlock;
  WindowControlBlock = Record
    X,Y      : Byte;          { start position }
    Hight    : Byte;          { Menu Hight     }
    Width    : Byte;          { Menu width     }
    ID       : Byte;          { Menu number    }
    BackLink : WindowLink;    { previous block }
    MenuItem : Byte;          { select item    }
    ScreenData : ScreenBlock; { saved screen data }
  end;
  String30 = String[30];
  ScreenPtr = ^ScreenRec;
  ScreenRec = Array [1..25,1..80] of Integer;

var         Screen       : ScreenPtr;
            ActiveWindow : Pointer;
            vystup:byte;
            meit:array[1..4] of byte;
            a,b,c:byte;
const       ken:string=('  1234567890-=  qwertyuiop[]  asdfghjkl;` \zxcvbnm,./ *             789-456+1230.');
            kes:string=('  !@#$%^&*()_+  QWERTYUIOP{}  ASDFGHJKL:"~ |ZXCVBNM<>? *             789-456+1230.');
            menu01:array[1..3] of string=(
            'Vytvorenie novho formulru',
            'Natanie formulru',
            'Koniec programu');

            menu02:array[1..5] of string=(
            'Nov',
            'Nata',
            'Uloi',
            'Uloi ako...',
            'Koniec');

            menu03:array[1..2] of string=(
            'Vloi text',
            'Vloi pole');

            menu04:array[1..3] of string=(
            'Sbor',
            'Editcia',
            'O programe');

Procedure InitWindows;
begin
  If LastMode = Mono Then
    Screen := Ptr($B000,0)
  Else
    Screen := Ptr($B800,0);
  ActiveWindow := Nil;
end;

Procedure OpenWindow(X, Y, Lines, Columns, FrameColor,
                     ForeGround, BackGround : Byte;
                     Title : String30; Shade : ShadeType);
Var
  A, X1, X2,
  Y1, Y2        : Integer;
  OldAttr       : Integer;
  WindowSize    : Integer;
  Block         : WindowLink;
begin
  OldAttr := TextAttr;

  WindowSize := (Lines + 3) * (Columns + 5) * 2 +
                 Sizeof(WindowControlBlock) - Sizeof(ScreenBlock);

  If MemAvail < WindowSize Then
  begin
    WriteLn;WriteLn('Program out of memory');
    Halt;
  end;

  GetMem(Block,WindowSize);
  Block^.X := X - 2;
  Block^.Y := Y - 1;
  Block^.Hight := Lines + 3;
  Block^.Width := Columns + 5;
  Block^.BackLink := ActiveWindow;

  ActiveWindow := Block;
  A := 1;
  For Y1 := Block^.Y to Block^.Y+Block^.Hight-1 Do
  begin
    Move(Screen^[Y1, Block^.X], Block^.ScreenData[A], Block^.Width * 2);
    A := A + Block^.Width;
  end;

  TextColor(FrameColor);
  If BackGround = Black Then
    TextBackGround(LightGray)    { This will keep exploding Window visable }
  Else
    TextBackground(BackGround);

  X1 := X + Columns Div 2;
  X2 := X1 + 1;
  Y1 := Y + Lines Div 2;
  Y2 := Y1 + 1;

  Repeat
    Window(X1, Y1, X2, Y2);
    ClrScr;
     Delay(10);  {ci je vidiet animacia okna}
    If X1 > X Then
      Dec(X1);
    If X2 < X + Columns Then
      Inc(X2);
    If Y1 > Y Then
      Dec(Y1);
    If Y2 < Y + Lines Then
      Inc(Y2);
  Until (X2 - X1 >= Columns ) And (Y2 - Y1 >= Lines);

  Window(X - 1, Y, X + Columns, Y + Lines);
  TextBackground(BackGround);
  ClrScr;
  TextColor(FrameColor);
  Window(1, 1, 80, 24);
  GotoXY(X - 2, Y - 1);
  Write('');
  For A := 1 to Columns + 2 Do
    Write('');

  Write('');
  For A := 1 to Lines Do
  begin
    GotoXY(X - 2, Y + A - 1);
    Write('');
    GotoXY(X + Columns + 1, Y + A - 1);
    Write('');
  end;
  GotoXY(X - 2, Y + Lines);
  Write('');
  For A := 1 to Columns + 2 Do
    Write('');
  Write('');
  If Shade = Shading Then
  begin
    For A := Y to Y + Lines + 1 Do
      Screen^[A, X + Columns + 2] := Screen^[A, X + Columns + 2] And $07FF;
    For A := X - 1 to X + Columns + 1 Do
      Screen^[Y + Lines + 1, A] := Screen^[Y + Lines + 1, A] And $07FF;
  end;
  If Title <> '' Then
  begin
    TextColor(FrameColor);
    GotoXY(X + ((Columns - Length(Title)) div 2) - 1, Y - 1);
    Write(' ', Title, ' ');
  end;
  Window(1, 1, 80, 24);
end;

Procedure CloseWindow;
Var
  Block   : WindowLink;
  A       : Integer;
  Y1      : Integer;
  WindowSize : Integer;
begin
  If ActiveWindow = Nil Then
    Exit;
  Block := ActiveWindow;
  WindowSize := (Block^.Hight) * (Block^.Width) * 2 +
                 Sizeof(WindowControlBlock) - Sizeof(ScreenBlock);
  A := 1;
  For Y1 := Block^.Y to Block^.Y+Block^.Hight - 1 Do
    begin
    Move(Block^.ScreenData[A], Screen^[Y1, Block^.X], Block^.Width * 2);
    A := A + Block^.Width;
    end;
  ActiveWindow := Block^.BackLink;
  FreeMem(Block, WindowSize);
end;

PROCEDURE CurOff; ASSEMBLER;
ASM
       MOV  AH, 1
       MOV  CX, 1400h
       INT  10h
END;

PROCEDURE CurOn; ASSEMBLER;
ASM
       MOV  AH, 1
       MOV  CX, 0607h
       INT  10h
END;

PROCEDURE CurSet( nTop, nBottom : INTEGER ); ASSEMBLER;
ASM
     MOV  AH, 1
     MOV  CH, BYTE PTR nTop
     MOV  CL, BYTE PTR nBottom
     INT  10h
END;

{ZACIATOK VLAST.PROGRAMU}
Procedure LineToMem(X, Y, Dlzka: Byte);  {riadok --> pamat}
Var
  A, X1, X2,
  Y1, Y2        : Integer;
  OldAttr       : Integer;
  WindowSize    : Integer;
  Block         : WindowLink;
begin
  OldAttr := TextAttr;

  WindowSize := (1) * (Dlzka) * 2 +
                 Sizeof(WindowControlBlock) - Sizeof(ScreenBlock);

  If MemAvail < WindowSize Then
  begin
    WriteLn;WriteLn('Program out of memory');
    Halt;
  end;

  GetMem(Block,WindowSize);
  Block^.X := X;
  Block^.Y := Y;
  Block^.Hight := 1;
  Block^.Width := Dlzka;
  Block^.BackLink := ActiveWindow;

  ActiveWindow := Block;
  A := 1;
  {For Y1 := Block^.Y to Block^.Y+Block^.Hight-1 Do
  begin}
    Move(Screen^[Y1, Block^.X], Block^.ScreenData[A], Block^.Width * 2);
  {  A := A + Block^.Width;
  end;}
end;

Procedure LineRestore;        {pamat --> riadok}
begin
closewindow;
end;

Procedure Doplnpasik(polozka:string;pasik:byte);
var j:byte;
begin;
for j:=length(polozka) to pasik do write(' ');
end;

{ake polozky,cislo menu,kolko ich je,kde x.y,dlzka pasika,farba pisma,bg,oznac pism,bg}
Procedure vyber(polozky:array of string;cislo,kolko,kx,ky,pasik,tcm,tbm,tcmo,tbmo:byte);
var i:byte;
begin
for i:=0 to kolko-1 do begin
    gotoxy(kx,ky+i);write(polozky[i]);
    end;
vystup:=0;
i:=meit[cislo];
repeat
clearwasdownarray;
textbackground(tbmo);
textcolor(tcmo);
gotoxy(kx-1,ky+i);write(' ',polozky[i]);doplnpasik(polozky[i],pasik);
if (wasdown[upscan])or(wasdown[downscan]) then begin
   textbackground(tbm);
   textcolor(tcm);
   gotoxy(kx-1,ky+i);write(' ',polozky[i]);doplnpasik(polozky[i],pasik);
   end;
if wasdown[upscan] then if i=0 then i:=kolko-1 else dec(i);
if wasdown[downscan] then if i=kolko-1 then i:=0 else inc(i);
until (wasdown[entscan])or(wasdown[escscan]);
if wasdown[entscan] then vystup:=i+1;
if wasdown[escscan] then vystup:=255;
clearwasdownarray;
textbackground(tbm);
textcolor(tcm);
meit[cislo]:=i;
end;

Procedure Menu_subor;
begin
openwindow(18,2,7,16,14,5,1,'Sbor',shading);
repeat
vyber(menu02,2,5,18,3,16,14,1,15,5);
until vystup=255;
closewindow;
if vystup=255 then vystup:=0;
end;

Procedure Menu_Editacia;
begin
openwindow(18,2,4,17,14,5,1,'Editcia',shading);
repeat
vyber(menu03,3,2,18,3,17,14,1,15,5);
until vystup=255;
closewindow;
if vystup=255 then vystup:=0;
end;

Procedure Editor_formulara;
begin
clrscr;

openwindow(3,2,5,10,14,5,1,'Formulr',shading);
repeat
vyber(menu04,4,3,3,3,10,14,1,15,5);
if vystup=1 then Menu_Subor;
if vystup=2 then Menu_Editacia;
until vystup=255;
closewindow;
if vystup=255 then vystup:=0;
end;

Procedure Menu;
begin
initwindows;
openwindow(10,5,5,30,14,5,1,'Hlavn menu',shading);
vyber(menu01,1,3,10,6,30,14,1,15,5);
closewindow;
textbackground(3);
if vystup=1 then Editor_formulara;
end;

begin
textbackground(3);
clrscr; {uvodny screen}
initnewkeyint;
curoff;
for a:=1 to 4 do begin
meit[a]:=0;
end;
menu;
curon;

setoldkeyint;
end.