{ovladanie textu,pola}
{urobit program pomocou games unity - ovladanie(ok),text(--)}
{text urobit s tym, ze v stringoch su ulozene znaky v poradi games unity}
{vytvoreny podprogram na zapamatanie obsahu riadku a na spatne vypisanie}
{urobit kurzor - ok}
{ - alt+127 - miesto space}
{ - alt+245 - miesto '}
{!!!!!!!! Dokoncit informacny pasik !!!!!!!!}
{informacia je cervena, ked je miesto umiestnenia nespravne}

Program mnotes;

uses crt,games;
Type
  ShadeType = (Shading, NoShading);
  ScreenBlock = Array [1..2000] of Integer;
  ScreenLine  = Array [1..80] of Word;
  ScreenArray = Array [1..25] of ScreenLine;
  WindowLink  = ^WindowControlBlock;
  WindowControlBlock = Record
    X,Y      : Byte;          { start position }
    Hight    : Byte;          { Menu Hight     }
    Width    : Byte;          { Menu width     }
    ID       : Byte;          { Menu number    }
    BackLink : WindowLink;    { previous block }
    MenuItem : Byte;          { select item    }
    ScreenData : ScreenBlock; { saved screen data }
  end;
  String30 = String[30];
  ScreenPtr = ^ScreenRec;
  ScreenRec = Array [1..25,1..80] of Integer;

var         Screen       : ScreenPtr;
            ActiveWindow : Pointer;
            comm:string[10];
            vystup:byte;
            meit:array[1..4] of byte;
            a,b,c,pot,pop:byte;
            tex:array[1..100] of record xt,yt,dlz:byte;pist:string[78] end;
            pol:array[1..100] of record typ,por,xp,yp,dlz:byte end;
const       ken:string=(' 1234567890-=  qwertyuiop[]  asdfghjkl;` \zxcvbnm,./ *              789-456+1230.');
            kes:string=(' !@#$%^&*()_+  QWERTYUIOP{}  ASDFGHJKL:"~ |ZXCVBNM<>? *                           ');
            menu01:array[1..3] of string=(
            'Vytvorenie novho formulru',
            'Natanie formulru',
            'Koniec programu');

            menu02:array[1..5] of string=(
            'Nov',
            'Nata',
            'Uloi',
            'Uloi ako...',
            'Koniec');

            menu03:array[1..5] of string=(
            'Zobrazit',
            'Modifikovat',
            'Vloi text',
            'Vloi pole',
            'Zmazat t/p');

            menu04:array[1..3] of string=(
            'Sbor',
            'Editcia',
            'O programe');

Procedure InitWindows;
begin
  If LastMode = Mono Then
    Screen := Ptr($B000,0)
  Else
    Screen := Ptr($B800,0);
  ActiveWindow := Nil;
end;

Procedure OpenWindow(X, Y, Lines, Columns, FrameColor,
                     ForeGround, BackGround : Byte;
                     Title : String30; Shade : ShadeType);
Var
  A, X1, X2,
  Y1, Y2        : Integer;
  OldAttr       : Integer;
  WindowSize    : Integer;
  Block         : WindowLink;
begin
  OldAttr := TextAttr;

  WindowSize := (Lines + 3) * (Columns + 5) * 2 +
                 Sizeof(WindowControlBlock) - Sizeof(ScreenBlock);

  If MemAvail < WindowSize Then
  begin
    WriteLn;WriteLn('Program out of memory');
    Halt;
  end;

  GetMem(Block,WindowSize);
  Block^.X := X - 2;
  Block^.Y := Y - 1;
  Block^.Hight := Lines + 3;
  Block^.Width := Columns + 5;
  Block^.BackLink := ActiveWindow;

  ActiveWindow := Block;
  A := 1;
  For Y1 := Block^.Y to Block^.Y+Block^.Hight-1 Do
  begin
    Move(Screen^[Y1, Block^.X], Block^.ScreenData[A], Block^.Width * 2);
    A := A + Block^.Width;
  end;

  TextColor(FrameColor);
  If BackGround = Black Then
    TextBackGround(LightGray)    { This will keep exploding Window visable }
  Else
    TextBackground(BackGround);

  X1 := X + Columns Div 2;
  X2 := X1 + 1;
  Y1 := Y + Lines Div 2;
  Y2 := Y1 + 1;

  Repeat
    Window(X1, Y1, X2, Y2);
    ClrScr;
     Delay(10);  {ci je vidiet animacia okna}
    If X1 > X Then
      Dec(X1);
    If X2 < X + Columns Then
      Inc(X2);
    If Y1 > Y Then
      Dec(Y1);
    If Y2 < Y + Lines Then
      Inc(Y2);
  Until (X2 - X1 >= Columns ) And (Y2 - Y1 >= Lines);

  Window(X - 1, Y, X + Columns, Y + Lines);
  TextBackground(BackGround);
  ClrScr;
  TextColor(FrameColor);
  Window(1, 1, 80, 24);
  GotoXY(X - 2, Y - 1);
  Write('');
  For A := 1 to Columns + 2 Do
    Write('');

  Write('');
  For A := 1 to Lines Do
  begin
    GotoXY(X - 2, Y + A - 1);
    Write('');
    GotoXY(X + Columns + 1, Y + A - 1);
    Write('');
  end;
  GotoXY(X - 2, Y + Lines);
  Write('');
  For A := 1 to Columns + 2 Do
    Write('');
  Write('');
  If Shade = Shading Then
  begin
    For A := Y to Y + Lines + 1 Do
      Screen^[A, X + Columns + 2] := Screen^[A, X + Columns + 2] And $07FF;
    For A := X - 1 to X + Columns + 1 Do
      Screen^[Y + Lines + 1, A] := Screen^[Y + Lines + 1, A] And $07FF;
  end;
  If Title <> '' Then
  begin
    TextColor(FrameColor);
    GotoXY(X + ((Columns - Length(Title)) div 2) - 1, Y - 1);
    Write(' ', Title, ' ');
  end;
  Window(1, 1, 80, 24);
end;

Procedure CloseWindow;
Var
  Block   : WindowLink;
  A       : Integer;
  Y1      : Integer;
  WindowSize : Integer;
begin
  If ActiveWindow = Nil Then
    Exit;
  Block := ActiveWindow;
  WindowSize := (Block^.Hight) * (Block^.Width) * 2 +
                 Sizeof(WindowControlBlock) - Sizeof(ScreenBlock);
  A := 1;
  For Y1 := Block^.Y to Block^.Y+Block^.Hight - 1 Do
    begin
    Move(Block^.ScreenData[A], Screen^[Y1, Block^.X], Block^.Width * 2);
    A := A + Block^.Width;
    end;
  ActiveWindow := Block^.BackLink;
  FreeMem(Block, WindowSize);
end;

PROCEDURE CurOff; ASSEMBLER;
ASM
       MOV  AH, 1
       MOV  CX, 1400h
       INT  10h
END;

PROCEDURE CurOn; ASSEMBLER;
ASM
       MOV  AH, 1
       MOV  CX, 0607h
       INT  10h
END;

PROCEDURE CurSet( nTop, nBottom : INTEGER ); ASSEMBLER;
ASM
     MOV  AH, 1
     MOV  CH, BYTE PTR nTop
     MOV  CL, BYTE PTR nBottom
     INT  10h
END;

{ZACIATOK VLAST.PROGRAMU}
Procedure LineToMem(X, Y, Dlzka: Byte);  {riadok --> pamat}
Var
  A, X1, X2,
  Y1, Y2        : Integer;
  OldAttr       : Integer;
  WindowSize    : Integer;
  Block         : WindowLink;
begin
  OldAttr := TextAttr;

  WindowSize := (1) * (Dlzka) * 2 +
                 Sizeof(WindowControlBlock) - Sizeof(ScreenBlock);

  If MemAvail < WindowSize Then
  begin
    WriteLn;WriteLn('Program out of memory');
    Halt;
  end;

  GetMem(Block,WindowSize);
  Block^.X := X;
  Block^.Y := Y;
  Block^.Hight := 1;
  Block^.Width := Dlzka;
  Block^.BackLink := ActiveWindow;

  ActiveWindow := Block;
  A := 1;
  {For Y1 := Block^.Y to Block^.Y+Block^.Hight-1 Do
  begin}
    y1:=block^.y;
    Move(Screen^[Y1, Block^.X], Block^.ScreenData[A], Block^.Width * 2);
  {  A := A + Block^.Width;
  end;}
end;

Procedure Doplnpasik(polozka:string;pasik:byte);
var j:byte;
begin;
for j:=length(polozka) to pasik do write(' ');
end;

{ake polozky,cislo menu,kolko ich je,kde x.y,dlzka pasika,farba pisma,bg,oznac pism,bg}
Procedure vyber(polozky:array of string;cislo,kolko,kx,ky,pasik,tcm,tbm,tcmo,tbmo:byte);
var i:byte;
begin
for i:=0 to kolko-1 do begin
    gotoxy(kx,ky+i);write(polozky[i]);
    end;
vystup:=0;
i:=meit[cislo];
repeat
clearwasdownarray;
textbackground(tbmo);
textcolor(tcmo);
gotoxy(kx-1,ky+i);write(' ',polozky[i]);doplnpasik(polozky[i],pasik);
if (wasdown[upscan])or(wasdown[downscan]) then begin
   textbackground(tbm);
   textcolor(tcm);
   gotoxy(kx-1,ky+i);write(' ',polozky[i]);doplnpasik(polozky[i],pasik);
   end;
if wasdown[upscan] then if i=0 then i:=kolko-1 else dec(i);
if wasdown[downscan] then if i=kolko-1 then i:=0 else inc(i);
until (wasdown[entscan])or(wasdown[escscan]);
if wasdown[entscan] then vystup:=i+1;
if wasdown[escscan] then vystup:=255;
clearwasdownarray;
textbackground(tbm);
textcolor(tcm);
meit[cislo]:=i;
end;

Procedure Writext(znaky:string;dlzka:byte);
var i:byte;
begin
for i:=1 to dlzka do write(znaky[i]);
end;

Procedure Wripole(typ,dlzka:byte);
var i:byte;
begin
if dlzka>0 then write(typ);
if dlzka>1 then for i:=1 to dlzka-1 do write(' ');
end;

Procedure Vloz_pole;
var i,xp,yp,xz,yz,typ:byte;
    dlz:shortint;
    flag,badplace:boolean;
begin
textbackground(3);
curon;curset(0,16);
xp:=2;yp:=2;dlz:=1;typ:=1;
repeat
clearwasdownarray;
linetomem(xp,yp,dlz-1);
badplace:=false;
for i:=1 to pop-1 do begin
    if (yp=pol[i].yp)and
       ((xp<pol[i].xp+pol[i].dlz)and(xp+dlz-1>pol[i].xp)) then badplace:=true;
end;
for i:=1 to pot-1 do begin
    if (yp=tex[i].yt)and
       ((xp<tex[i].xt+tex[i].dlz)and(xp+dlz-1>tex[i].xt)) then badplace:=true;
end;
if badplace=true then textbackground(4) else textbackground(6);
gotoxy(xp,yp);wripole(typ,dlz-1);
repeat
flag:=false;
if wasdown[scanof(' ')] then begin
                             inc(dlz);
                             if dlz>79 then dec(dlz);
                             flag:=true;
                             end;
if (wasdown[backscan])and(dlz>1) then begin
                          dec(dlz);
                          if dlz<1 then inc(dlz);
                          flag:=true;
                          end;
if keydown[lshscan] then begin
   xz:=xp;yz:=yp;
   if (wasdown[pgupscan])and(typ>1) then begin;dec(typ);flag:=true;end;
   if (wasdown[pgdnscan])and(typ<3) then begin;inc(typ);flag:=true;end;
   if (wasdown[upscan])and(yp>2) then dec(yp);
   if (wasdown[downscan])and(yp<24) then inc(yp);
   if (wasdown[leftscan])and(xp>2) then dec(xp);
   if (wasdown[rightscan])and(xp<81) then inc(xp);
   if (xz<>xp)or(yz<>yp) then flag:=true;
   end;
  {if xp=0 then xp:=1; }
  if xp+dlz>81 then xp:=81-dlz;
if (wasdown[escscan])or(wasdown[entscan]) then flag:=true;
until flag=true;
closewindow;
until (wasdown[escscan])or((badplace=false)and(wasdown[entscan]));
curset(14,16);
curoff;
if wasdown[entscan] then begin
                    closewindow;
                    gotoxy(xp,yp);wripole(1,dlz-1);
                    pol[pop].xp:=xp;pol[pop].yp:=yp;
                    pol[pop].typ:=typ;
                    pol[pop].dlz:=dlz-1;
                    inc(pop);
                    end;
comm:='';
clearwasdownarray;


end;
Procedure Vloz_text;
var i,xp,yp:byte;
    dlz:shortint;
    flag,badplace:boolean;
begin
textbackground(2);
curon;curset(0,16);
xp:=2;yp:=2;dlz:=1;
tex[pot].pist:='                                                                              ';
repeat
clearwasdownarray;
linetomem(xp,yp,dlz-1);
badplace:=false;
for i:=1 to pot-1 do begin
    if (yp=tex[i].yt)and
       ((xp<tex[i].xt+tex[i].dlz)and(xp+dlz-1>tex[i].xt)) then badplace:=true;
end;
for i:=1 to pop-1 do begin
    if (yp=pol[i].yp)and
       ((xp<pol[i].xp+pol[i].dlz)and(xp+dlz-1>pol[i].xp)) then badplace:=true;
end;
if badplace=true then textbackground(4) else textbackground(2);
gotoxy(xp,yp);writext(tex[pot].pist,dlz-1);
i:=0;flag:=false;
repeat
inc(i);if i=128 then i:=0;
if (wasdown[i]) then begin
   if (kes[i]<>' ')and((keydown[lshscan]=true)or
                       (keydown[rshscan]=true)) then begin;
                       if kes[i]='' then kes[i]:='';
                       tex[pot].pist[dlz]:=kes[i];
                       inc(dlz);
                       if dlz>79 then dec(dlz);
                       if dlz<1 then inc(dlz);
                       end;

   if (ken[i]<>' ')and((keydown[lshscan]=false)and
                       (keydown[rshscan]=false)) then begin;
                       if ken[i]='' then ken[i]:='';
                       if ken[i]='' then ken[i]:='''';
                       tex[pot].pist[dlz]:=ken[i];
                       inc(dlz);
                       if dlz>79 then dec(dlz);
                       if dlz<1 then inc(dlz);
                       end;
  if (keydown[backscan])and(dlz>1) then begin;
                                        dec(dlz);tex[pot].pist[dlz]:=' ';
                                        end;
  if keydown[lshscan] then begin
   if (keydown[upscan])and(yp>2) then dec(yp);
   if (keydown[downscan])and(yp<24) then inc(yp);
   if (keydown[leftscan])and(xp>2) then dec(xp);
   if (keydown[rightscan])and(xp<81) then inc(xp);
   end;
  {if xp=0 then xp:=1; }
  if xp+dlz>81 then xp:=81-dlz;
  closewindow;
  flag:=true;
  end;
{gotoxy(10,10);write(tex[1].pist[dlz]);writeln(ken[i]);
}
until flag=true;
until ((badplace=false)and(wasdown[entscan]))or(wasdown[escscan]);
curset(14,16);
curoff;
if wasdown[entscan] then begin
                    closewindow;
                    gotoxy(xp,yp);writext(tex[pot].pist,dlz-1);
                    tex[pot].xt:=xp;tex[pot].yt:=yp;
                    tex[pot].dlz:=dlz-1;
                    inc(pot);
                    end;
comm:='';
clearwasdownarray;
end;

Procedure Menu_subor;
begin
openwindow(18,2,7,16,14,5,1,'Sbor',shading);
repeat
vyber(menu02,2,5,18,3,16,14,1,15,5);
until vystup=255;
closewindow;
if vystup=255 then vystup:=0;
end;
{penWindow(X, Y, Lines, Columns, FrameColor,
                     ForeGround, BackGround : Byte;
                     Title : String30; Shade : ShadeType);
 }
{Vyber
ake polozky,cislo menu,kolko ich je,kde x.y,dlzka pasika,
farba pisma,bg,oznac pism,bg}
Procedure Menu_Editacia;
begin
openwindow(18,2,7,17,14,5,1,'Editcia',shading);
comm:='';
vyber(menu03,3,5,18,3,17,14,1,15,5);
if vystup=1 then comm:='zobraz';
if vystup=3 then comm:='vloz_text';
if vystup=4 then comm:='vloz_pole';
closewindow;
if vystup=255 then vystup:=0 else vystup:=255;
end;

Procedure Editor_formulara;
begin
clrscr;
repeat
openwindow(3,2,5,10,14,5,1,'Formulr',shading);
repeat
vyber(menu04,4,3,3,3,10,14,1,15,5);
if vystup=1 then Menu_Subor;
if vystup=2 then Menu_Editacia;
until vystup=255;
closewindow;
if vystup=255 then vystup:=0;
if comm='vloz_text' then vloz_text;
if comm='vloz_pole' then vloz_pole;
if comm='zobraz' then repeat until keydown[scanof(' ')];
until wasdown[escscan];
end;

Procedure Menu;
begin
initwindows;
openwindow(10,5,5,30,14,5,1,'Hlavn menu',shading);
vyber(menu01,1,3,10,6,30,14,1,15,5);
closewindow;
textbackground(3);
if vystup=1 then Editor_formulara;
end;

begin
pot:=1;pop:=1;
textbackground(3);
clrscr; {uvodny screen}
initnewkeyint;
curoff;
for a:=1 to 4 do begin
meit[a]:=0;
end;
menu;
curon;

setoldkeyint;
end.