Program myrot;
uses crt,xvga;
CONST  POINTS:array[1..8] OF tpoint32=(
       (-20,-20,20),
       (20,-20,20),
       (20,20,20),
       (-20,20,20),
       (-20,-20,-20),
       (20,-20,-20),
       (20,20,-20),
       (-20,20,-20));
       FACES:array[1..12] of tpoint32=(
       (5,6,7),
       (7,8,5),
       (4,8,7),
       (7,3,4),
       (7,6,2),
       (2,3,7),
       (2,1,4),
       (4,3,2),
       (4,1,5),
       (5,8,4),
       (2,6,5),
       (5,1,2));
VAR    CPoints		: Array[1..High(Points)] Of TPoint32;
       FaceList	: Array[1..High(Faces)] Of TSortRec32;
       X1,Y1,Z1	: Integer;
       x2,Y2,Z2	: Integer;
       X3,Y3,Z3	: Integer;
       C1,C2,C3	: Integer;
       xb,yb,zb:array[1..8] of integer;
       screen:word;
       scrptr:pointer;
       faceindex,index:word;
       al,be,ga:integer;
Procedure InitGr;
begin
Xmode(true);
getmem(scrptr,64016);
screen:=seg(scrptr^)+1;
clearfake(screen);
end;

begin
initgr;
al:=10;be:=10;ga:=10;
For Index:=0 To 63 Do
XSetRGB(Index,Index,Index,Index);
initsincos(10);

repeat
ClearFake(screen);
AsmRotate32(Points,CPoints,High(Points),al,be,ga);
AddPerspective32(CPoints,High(Points),8,150);
MovePoints32(CPoints,High(Points),160,100,0);
For Index:=1 To High(Faces) Do Begin
			FaceList[Index].ID:=Index;
			FaceList[Index].SortValue:=
				CPoints[Faces[Index,1],3]+
				CPoints[Faces[Index,2],3]+
				CPoints[Faces[Index,3],3];
end;
QSort32(FaceList,High(Faces));
For Index:=1 To High(Faces) Do Begin
			FaceIndex:=FaceList[Index].ID;

			X1:=CPoints[Faces[FaceIndex,1],1];
			Y1:=CPoints[Faces[FaceIndex,1],2];
			Z1:=CPoints[Faces[FaceIndex,1],3];

			X2:=CPoints[Faces[FaceIndex,2],1];
			Y2:=CPoints[Faces[FaceIndex,2],2];
			Z2:=CPoints[Faces[FaceIndex,2],3];

			X3:=CPoints[Faces[FaceIndex,3],1];
			Y3:=CPoints[Faces[FaceIndex,3],2];
			Z3:=CPoints[Faces[FaceIndex,3],3];

			If Visible(X1,Y1,X2,Y2,X3,Y3)>=0 Then Begin
				C1:=28-(Z1 Div 2);
				C2:=28-(Z2 Div 2);
				C3:=28-(Z3 Div 2);

XTetraGouradclip(X1+80,Y1,C1,X2+80,Y2,C2,X3+80,Y3,C3,95,35,220,170,screen);
XTetraGouradclip(X1-30,Y1,C1,X2-30,Y2,C2,X3-30,Y3,C3,95,35,220,170,screen);
                        xbox(95,35,220,170,10,screen);
			End;
		End;
                al:=al+3;
                be:=be+3;
                ga:=ga+4;
                testcpu;
		{VRet;}
		ShowFake(screen);

until keypressed;
xmode(false);
end.