     {COOLTRIS by Matin Simecek - Version 0.09}
Program TETRIS;
uses crt,xvga;
var fakptr:pointer;
    screen:word;
    ll,pp:array[1..4] of byte;
    segment:array[1..4,1..4] of byte;
    pomseg:array[1..4,1..4] of byte;
    key,i,j,k,l,m,x,y,xs,ys:byte;
    stop,color,lavo,pravo:byte;
const kusy:array[1..4] of byte =(
      1,1,1,0);

Procedure UrobSegment;
begin
for j:=1 to 4 do begin
l:=8;m:=kusy[j];
for i:=1 to 4 do begin
segment[i,j]:=0;
if m>=l then begin;m:=m-l;segment[i,j]:=1;end;
l:=round(l/2);
end;end;end;

Procedure InitGraph;
begin
getmem(fakptr,64016);
screen:=seg(fakptr^)+1;
clearfake(screen);
for i:=1 to 63 do begin
xsetrgb(i,i,i,i);
end;
end;

Procedure Studna;
var a:integer;
begin
for a:=2 to 10 do begin
xline(10-a,10+a,10-a,150+a,9-a,screen);
xline(10-a,150+a,117+a,150+a,9-a,screen);
xline(117+a,150+a,117+a,10+a,9-a,screen);
end;
end;

Procedure Vykresli;
var a,b:byte;
begin
for b:=1 to 4 do begin
for a:=1 to 4 do begin
if segment[a,b]=1 then begin
xquadra(x+a*5,y+b*5,x+a*5+4,y+b*5,x+a*5+4,y+b*5+4,x+a*5,y+b*5+4,color,screen);
end;
end;
end;
if color=7 then color:=16;
end;

Procedure Zmaz;
var a,b:byte;
begin
for b:=1 to 4 do begin
for a:=1 to 4 do begin
if segment[a,b]=1 then begin
xquadra(x+a*5,y+b*5,x+a*5+4,y+b*5,x+a*5+4,y+b*5+4,x+a*5,y+b*5+4,0,screen);
end;
end;
end;
end;

Procedure Clearsegment;
begin
for i:=1 to 4 do begin
for j:=1 to 4 do begin
segment[i,j]:=0;end;end;end;

Procedure Clearpomseg;
begin
for i:=1 to 4 do begin
for j:=1 to 4 do begin
pomseg[i,j]:=0;end;end;end;

Procedure Rotuj;
begin
clearpomseg;
for i:=1 to 4 do begin
for j:=1 to 4 do begin
pomseg[i,j]:=segment[i,j];end;end;
clearsegment;
for i:=1 to 4 do begin
for j:=1 to 4 do begin
segment[i,j]:=pomseg[j,5-i];end;end;
end;

Procedure posunl;
begin
for i:=1 to 5 do begin
zmaz;dec(x);vykresli;vret;showfake(screen);end;end;

Procedure posunr;
begin
for i:=1 to 5 do begin
zmaz;inc(x);vykresli;vret;showfake(screen);end;end;

Procedure lavoseg;
begin
for j:=1 to 4 do ll[j]:=0;
xs:=1;ys:=1;
repeat;
repeat;
if segment[xs,ys]=1 then begin
   ll[ys]:=xs;xs:=4;end;

inc(xs);
until xs>=5;
inc(ys);
xs:=1;
until ys>=5;
end;

Procedure pravoseg;
begin
for j:=1 to 4 do pp[j]:=0;
xs:=1;ys:=1;
repeat;
repeat;
if segment[5-xs,ys]=1 then begin
   pp[ys]:=5-xs;xs:=4;end;
inc(xs);
until xs>=5;
inc(ys);
xs:=1;
until ys>=5;
end;

Procedure Testchodulavo;
begin;
lavoseg;
lavo:=0;
for i:=1 to 4 do begin
if ll[i]>0 then begin
l:=xgetpixel(x+ll[i]*5-1,y+i*5,screen);
j:=xgetpixel(x+ll[i]*5-1,y+i*5+4,screen);
{xplot(x+ll[i]*5-1,y+i*5,32,screen);
xplot(x+ll[i]*5-1,y+i*5+4,32,screen);
}if (j=7)or(l=7)then lavo:=1;end;
end;
end;

Procedure testchodupravo;
begin
pravoseg;
pravo:=0;
for i:=1 to 4 do begin
if pp[i]>0 then begin
l:=xgetpixel(x+pp[i]*5+5,y+i*5,screen);
j:=xgetpixel(x+pp[i]*5+5,y+i*5+4,screen);
{xplot(x+pp[i]*5+5,y+i*5,32,screen);
xplot(x+pp[i]*5+5,y+i*5+4,32,screen);
}if (j=7)or(l=7) then pravo:=1;end;
end;
end;

Procedure testchodudolu;
begin
for i:=1 to 4 do begin
for j:=1 to 4 do begin
if segment[j,i]=1 then begin
l:=xgetpixel(x+j*5+2,y+i*5+4,screen);
if l=7 then begin;dec(y);stop:=1;color:=7;end;
end;end;end;
end;

Procedure Ovladaj;
begin
key:=ord(readkey);
if key=75 then begin;if lavo=0 then begin;zmaz;posunl;end;end;
if key=77 then begin;if pravo=0 then begin;zmaz;posunr;end;end;
if key=72 then begin;zmaz;rotuj;end;
end;

Procedure Padaj;
begin
delay(15);
zmaz;inc(y);
end;

begin
x:=10;
color:=16;
xmode(true);
InitGraph;
studna;
Urobsegment;
repeat;
if y>160 then y:=1;
if keypressed then begin;testchodulavo;testchodupravo;ovladaj;end;
padaj;
testchodudolu;
Vykresli;
if stop=1 then begin;x:=10;stop:=0;y:=10;end;

vret;
showfake(screen);
until key=27;
readkey;
xmode(false);
end.
